#ifndef effect_matrix_H
#define effect_matrix_H

#include "prototypes.h"
#include "Effect.h"
#include "config.h"
#include "my_fastled.h"
#include "my_color_palettes.h"

class MatrixEffectColumn {
private:
    int x, y;
    int length;
    Window* window;
    uint16_t speed;
    boolean running;
    unsigned long last_move = 0;
public:
    MatrixEffectColumn();
    MatrixEffectColumn(Window* win, int xPos);

    void start();

    void advance();

    void draw();

    void loop();
};

class MatrixEffect : public Effect {
private:
    MatrixEffectColumn* _columns;
public:
    boolean can_be_shown_with_clock();
    void start();
    void stop();
    MatrixEffect();
    void loop();
};

#endif
