#pragma once
#include "config.h"

#ifdef MQTT_ENABLE

#include <PubSubClient.h>
#include <Arduino.h>

void mqtt_callback(char* complete_topic, byte* pl, unsigned int length);

boolean mqtt_connect();

extern uint8_t weather_icon_ids[6];
extern int8_t weather_temperatures[6];

void mqtt_setup();

void mqtt_loop();

void mqtt_publish(const char* topic, int number);

void mqtt_log(const char* message);
void mqtt_log(int number);
void mqtt_log(long unsigned int number);
void mqtt_log(long int number);
void mqtt_log(String str);

void mqtt_log_ln(const char* message);
void mqtt_log_ln(int number);
void mqtt_log_ln(long unsigned int number);
void mqtt_log_ln(long int number);
void mqtt_log_ln(String str);


void mqtt_log_send(const char* message);

extern String mqtt_log_str;

#endif // MQTT_ENABLE
