#pragma once

#include <Arduino.h>

typedef struct {
    uint8_t *colors;
    uint8_t *data;
    uint16_t *offsets;
    uint16_t *delays;
    boolean individual_delays;
    int color_count;
    int frame_count;
    int w;
    int h;
} AnimationData;

typedef struct {
	uint8_t width;
	uint8_t height;
	const uint8_t *data;
	bool (*isCharAllowed)(const char);
	uint16_t (*getCharPosition)(const char);
} Font;

typedef struct Vector {
    double x1;
    double x2;
} Vector;

typedef struct Matrix {
    double a11;
    double a12;
    double a21;
    double a22;
} Matrix;

typedef struct {
    uint16_t x;
    uint16_t y;
} Coords;

extern uint8_t baseHue;
extern char hostname[30];
